<?php

$store_name = "metahuman";

function json_error($msg, $code = 500) {
  if ($code == 500) {
    Header( "HTTP/1.1 500 Internal Server Error" );
  } else if ($code == 403) {
    Header( "HTTP/1.1 403 Forbidden" );
  } else if ($code == 404) {
    Header( "HTTP/1.1 404 Not Found" );
  } else if ($code == 400) {
    Header( "HTTP/1.1 400 Bad Request" );
  } else if ($code == 409) {
    Header( "HTTP/1.1 409 Conflict" );
  }
  Header( "Content-Type: application/javascript");
  
  echo json_encode(array('error' => $msg))."\n";
  throw new Exception($msg);
}

if ($store_name == "INSERTINSERTINSERT") {
  return json_error("store name not configured", 500);
}

function search_purchases($needles, $purchased) {
  $purchasedMap = array();
  foreach ($purchased as $purchase) {
    $purchasedMap[$purchase] = 1;
  }
  $results = array();
  foreach ($needles as $needle) {
    $results[$needle] = array_key_exists($needle, $purchasedMap);
  }
  return $results;
}

$full_path = $_SERVER['REQUEST_URI'];

$last_slash_index = strrpos($full_path, "/");
$scene_filename = substr($full_path, $last_slash_index+1);

preg_match("!/(\w+)\.txt(\.json)?!", $full_path, $matches);
$scene_name = $matches[1];

$debug_log = 0;

if ($debug_log) {
  error_log("full_path $full_path");
  error_log("store_name $store_name");
  error_log("scene_filename $scene_filename");
  error_log("scene_name: $scene_name");
}

if (!file_exists("mygame.js")) {
  return json_error("couldn't find mygame", 404);
}

if (!file_exists("scenes/$scene_filename")) {
  return json_error("couldn't find scene", 404);
}

$mygame = file_get_contents("mygame.js");
preg_match("/purchases =\s*({[^}]*})/s", $mygame, $matches);
$purchases = json_decode($matches[1], true);

$ok = true;

if ($purchases && array_key_exists($scene_name, $purchases)) {
  session_name("cog");
  session_set_cookie_params(0,'/',"",true,true);
  session_start();
  if (!array_key_exists("login_id", $_SESSION)) json_error("not registered", 403);
  $product = $store_name.".".$purchases[$scene_name];
  $purchased = $_SESSION["purchases"];
  $ok = false;
  foreach ($purchased as $purchase) {
    if ($product == $purchase) {
      $ok = true;
      break;
    }
  }
  if (!$ok) json_error("not purchased", 403);
}

if ($debug_log) error_log("ok: $ok");

if (preg_match("/\.txt$/", $scene_filename)) {
  header("Content-Type: text/plain");
} else if (preg_match("/\.json$/", $scene_filename)) {
  header("Content-Type: application/json");
}

echo file_get_contents("scenes/$scene_filename");

?>